diff --git a/src/backend/parser/parse_graphtable.c b/src/backend/parser/parse_graphtable.c
index 73fbfb541f7..07773f0b07a 100644
--- a/src/backend/parser/parse_graphtable.c
+++ b/src/backend/parser/parse_graphtable.c
@@ -18,15 +18,16 @@
 #include "access/genam.h"
 #include "access/htup_details.h"
 #include "access/table.h"
-#include "catalog/pg_propgraph_label.h"
+#include "catalog/pg_propgraph_element.h"
+#include "catalog/pg_propgraph_element_label.h"
 #include "catalog/pg_propgraph_property.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
+#include "optimizer/cost.h"
 #include "parser/parse_collate.h"
 #include "parser/parse_expr.h"
 #include "parser/parse_graphtable.h"
 #include "parser/parse_node.h"
-#include "utils/fmgroids.h"
 #include "utils/lsyscache.h"
 #include "utils/relcache.h"
 #include "utils/syscache.h"
@@ -240,7 +241,7 @@ transformGraphElementPattern(ParseState *pstate, GraphElementPattern *gep)
 {
 	GraphTableParseState *gpstate = pstate->p_graph_table_pstate;
 
-	if (gep->quantifier)
+	if (!enable_native_graphtable && gep->quantifier)
 		ereport(ERROR,
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("element pattern quantifier is not supported")));
@@ -367,6 +368,364 @@ transformPathPatternList(ParseState *pstate, List *path_pattern)
 	return (Node *) result;
 }
 
+/*
+ * Collect label OIDs from a label expression (GraphLabelRef or BoolExpr of
+ * GraphLabelRef nodes) into a list.  Returns NIL if labelexpr is NULL.
+ */
+static List *
+collect_label_oids(Node *labelexpr)
+{
+	List	   *result = NIL;
+
+	if (labelexpr == NULL)
+		return NIL;
+
+	if (IsA(labelexpr, GraphLabelRef))
+	{
+		GraphLabelRef *lref = (GraphLabelRef *) labelexpr;
+
+		result = lappend_oid(result, lref->labelid);
+	}
+	else if (IsA(labelexpr, BoolExpr))
+	{
+		BoolExpr   *b = (BoolExpr *) labelexpr;
+		ListCell   *lc;
+
+		foreach(lc, b->args)
+		{
+			Node	   *arg = (Node *) lfirst(lc);
+
+			if (IsA(arg, GraphLabelRef))
+				result = lappend_oid(result,
+									 ((GraphLabelRef *) arg)->labelid);
+		}
+	}
+
+	return result;
+}
+
+/*
+ * Validate that no two element patterns in the same path have the same
+ * variable name with incompatible definitions.
+ *
+ * Cases:
+ * 1. Same variable, different element kinds (vertex vs edge) → error
+ * 2. Same variable, both vertex, different label expressions → error
+ * 3. Same variable, both vertex, compatible label expressions → allowed
+ */
+static void
+validate_element_variable_names(GraphPattern *pattern)
+{
+	List	   *path;
+	int			path_len;
+	int			i;
+
+	if (pattern == NULL ||
+		pattern->path_pattern_list == NIL)
+		return;
+
+	path = linitial(pattern->path_pattern_list);
+	if (path == NULL)
+		return;
+	path_len = list_length(path);
+
+	for (i = 0; i < path_len; i++)
+	{
+		GraphElementPattern *gep_i = (GraphElementPattern *)
+			list_nth(path, i);
+		int			j;
+
+		if (gep_i == NULL || gep_i->variable == NULL)
+			continue;
+
+		for (j = i + 1; j < path_len; j++)
+		{
+			GraphElementPattern *gep_j = (GraphElementPattern *)
+				list_nth(path, j);
+
+			if (gep_j == NULL || gep_j->variable == NULL)
+				continue;
+
+			if (strcmp(gep_i->variable, gep_j->variable) != 0)
+				continue;
+
+			/*
+			 * Same variable name.  Check if element pattern types differ
+			 * (vertex vs edge).
+			 */
+			if (gep_i->kind != gep_j->kind &&
+				!(IS_EDGE_PATTERN(gep_i->kind) &&
+				  IS_EDGE_PATTERN(gep_j->kind)))
+			{
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("element patterns with same variable "
+								"name \"%s\" but different element "
+								"pattern types", gep_i->variable)));
+			}
+
+			/*
+			 * Same kind (both vertex or both edge).  Check label expressions.
+			 * Error only if both have non-NULL label expressions that differ.
+			 */
+			if (gep_i->labelexpr != NULL && gep_j->labelexpr != NULL &&
+				!equal(gep_i->labelexpr, gep_j->labelexpr))
+			{
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("element patterns with same "
+								"variable name \"%s\" but "
+								"different label expressions "
+								"are not supported",
+								gep_i->variable)));
+			}
+		}
+	}
+}
+
+/*
+ * Validate that an edge variable appearing at multiple hop positions
+ * always connects the same pair of vertex variables.  For example, in
+ * (a)->[e]->(b)<-[e]-(c), the edge e appears twice connecting a→b and
+ * c→b, which requires e to connect three vertices — an impossibility.
+ */
+static void
+validate_edge_connectivity(GraphPattern *pattern)
+{
+	List	   *path;
+	int			path_len;
+	int			n_hops;
+
+	if (pattern == NULL ||
+		pattern->path_pattern_list == NIL)
+		return;
+
+	path = linitial(pattern->path_pattern_list);
+	if (path == NULL)
+		return;
+	path_len = list_length(path);
+	if (path_len < 4)			/* need at least (v)-[e]->(v)-[e]->(v) */
+		return;
+
+	n_hops = (path_len - 1) / 2;
+	{
+		int			hi;
+
+		for (hi = 0; hi < n_hops; hi++)
+		{
+			int			edge_pi = 2 * hi + 1;
+			GraphElementPattern *edge_gep = (GraphElementPattern *)
+				list_nth(path, edge_pi);
+			int			ji;
+
+			if (edge_gep == NULL || edge_gep->variable == NULL ||
+				!IS_EDGE_PATTERN(edge_gep->kind))
+				continue;
+
+			for (ji = hi + 1; ji < n_hops; ji++)
+			{
+				int			je_pi = 2 * ji + 1;
+				GraphElementPattern *je_gep = (GraphElementPattern *)
+					list_nth(path, je_pi);
+				int			src_pi_i;
+				int			dst_pi_i;
+				int			src_pi_j;
+				int			dst_pi_j;
+				GraphElementPattern *src_gep_i;
+				GraphElementPattern *dst_gep_i;
+				GraphElementPattern *src_gep_j;
+				GraphElementPattern *dst_gep_j;
+
+				if (je_gep == NULL || je_gep->variable == NULL ||
+					!IS_EDGE_PATTERN(je_gep->kind))
+					continue;
+
+				if (strcmp(edge_gep->variable, je_gep->variable) != 0)
+					continue;
+
+				/* Same edge variable at two hop positions */
+				src_pi_i = 2 * hi;
+				dst_pi_i = 2 * hi + 2;
+				src_pi_j = 2 * ji;
+				dst_pi_j = 2 * ji + 2;
+
+				src_gep_i = (GraphElementPattern *) list_nth(path, src_pi_i);
+				dst_gep_i = (GraphElementPattern *) list_nth(path, dst_pi_i);
+				src_gep_j = (GraphElementPattern *) list_nth(path, src_pi_j);
+				dst_gep_j = (GraphElementPattern *) list_nth(path, dst_pi_j);
+
+				/*
+				 * An edge variable connecting multiple hops must have the
+				 * same source and destination vertex variables in each hop.
+				 * If either side differs, the edge would need to connect more
+				 * than two distinct vertices.
+				 */
+				if ((src_gep_i->variable == NULL ||
+					 dst_gep_i->variable == NULL ||
+					 src_gep_j->variable == NULL ||
+					 dst_gep_j->variable == NULL) ||
+					strcmp(src_gep_i->variable, src_gep_j->variable) != 0 ||
+					strcmp(dst_gep_i->variable, dst_gep_j->variable) != 0)
+				{
+					ereport(ERROR,
+							(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+							 errmsg("an edge cannot connect more than two "
+									"vertices even in a cyclic pattern")));
+				}
+			}
+		}
+	}
+}
+
+/*
+ * Check that each label used in an element pattern matches the element's
+ * kind (vertex or edge).  A label that only appears on vertex elements
+ * cannot be used in an edge pattern, and vice versa.
+ */
+static void
+validate_element_label_kinds(GraphPattern *pattern, Oid graph_oid)
+{
+	List	   *path;
+	int			path_len;
+	int			pi;
+
+	if (pattern == NULL ||
+		pattern->path_pattern_list == NIL)
+		return;
+
+	path = linitial(pattern->path_pattern_list);
+	if (path == NULL)
+		return;
+	path_len = list_length(path);
+
+	for (pi = 0; pi < path_len; pi++)
+	{
+		GraphElementPattern *gep = (GraphElementPattern *)
+			list_nth(path, pi);
+		List	   *label_oids;
+		ListCell   *lc;
+		char		elem_kind;
+		const char *kind_str;
+
+		if (gep == NULL || gep->labelexpr == NULL)
+			continue;
+
+		/*
+		 * Determine what kind this pattern element should be.
+		 */
+		if (gep->kind == VERTEX_PATTERN)
+		{
+			elem_kind = 'v';
+			kind_str = "vertex";
+		}
+		else if (IS_EDGE_PATTERN(gep->kind))
+		{
+			elem_kind = 'e';
+			kind_str = "edge";
+		}
+		else
+			continue;
+
+		label_oids = collect_label_oids(gep->labelexpr);
+		if (label_oids == NIL)
+			continue;
+
+		/*
+		 * For each label OID, scan pg_propgraph_element_label joined with
+		 * pg_propgraph_element to find what element kinds this label is
+		 * associated with.
+		 */
+		foreach(lc, label_oids)
+		{
+			Oid			labelid = lfirst_oid(lc);
+			Relation	el_label_rel;
+			SysScanDesc el_label_scan;
+			HeapTuple	el_label_tup;
+			bool		has_vertex = false;
+			bool		has_edge = false;
+
+			el_label_rel = table_open(PropgraphElementLabelRelationId,
+									  AccessShareLock);
+			el_label_scan = systable_beginscan(el_label_rel, InvalidOid,
+											   false, NULL, 0, NULL);
+
+			while (HeapTupleIsValid(el_label_tup =
+									systable_getnext(el_label_scan)))
+			{
+				Form_pg_propgraph_element_label el_form =
+					(Form_pg_propgraph_element_label) GETSTRUCT(el_label_tup);
+
+				if (el_form->pgellabelid != labelid)
+					continue;
+
+				/*
+				 * Look up the element to find its kind.
+				 */
+				{
+					HeapTuple	elem_tup;
+					Form_pg_propgraph_element elem_form;
+
+					elem_tup = SearchSysCache1(PROPGRAPHELOID,
+											   ObjectIdGetDatum(
+																el_form->pgelelid));
+					if (!HeapTupleIsValid(elem_tup))
+						continue;
+					elem_form = (Form_pg_propgraph_element)
+						GETSTRUCT(elem_tup);
+					if (elem_form->pgepgid == graph_oid)
+					{
+						if (elem_form->pgekind == 'v')
+							has_vertex = true;
+						else if (elem_form->pgekind == 'e')
+							has_edge = true;
+					}
+					ReleaseSysCache(elem_tup);
+				}
+
+				if (has_vertex && has_edge)
+					break;
+			}
+
+			systable_endscan(el_label_scan);
+			table_close(el_label_rel, AccessShareLock);
+
+			/*
+			 * If the label is not associated with the required kind, produce
+			 * the standard error.
+			 */
+			if ((elem_kind == 'v' && !has_vertex) ||
+				(elem_kind == 'e' && !has_edge))
+			{
+				const char *labelname;
+
+				labelname = get_propgraph_label_name(labelid);
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("no property graph element of type "
+								"\"%s\" has label \"%s\" associated "
+								"with it in property graph \"%s\"",
+								kind_str, labelname,
+								get_rel_name(graph_oid))));
+			}
+		}
+	}
+}
+
+/*
+ * Run all native-specific validations on a graph pattern.
+ * Called from transformGraphPattern when enable_native_graphtable is on.
+ */
+static void
+validate_native_graph_query(ParseState *pstate,
+							GraphPattern *pattern)
+{
+	GraphTableParseState *gpstate = pstate->p_graph_table_pstate;
+
+	validate_element_variable_names(pattern);
+	validate_edge_connectivity(pattern);
+	validate_element_label_kinds(pattern, gpstate->graphid);
+}
+
 /*
  * Transform a GraphPattern.
  *
@@ -390,5 +749,8 @@ transformGraphPattern(ParseState *pstate, GraphPattern *graph_pattern)
 	graph_pattern->whereClause = transformExpr(pstate, graph_pattern->whereClause, EXPR_KIND_WHERE);
 	assign_expr_collations(pstate, graph_pattern->whereClause);
 
+	if (enable_native_graphtable)
+		validate_native_graph_query(pstate, graph_pattern);
+
 	return (Node *) graph_pattern;
 }
diff --git a/src/backend/rewrite/rewriteGraphTable.c b/src/backend/rewrite/rewriteGraphTable.c
index cdb1f4c0dca..ec2845ef4f2 100644
--- a/src/backend/rewrite/rewriteGraphTable.c
+++ b/src/backend/rewrite/rewriteGraphTable.c
@@ -25,6 +25,7 @@
 #include "catalog/pg_propgraph_property.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
+#include "optimizer/cost.h"
 #include "nodes/nodeFuncs.h"
 #include "optimizer/optimizer.h"
 #include "parser/analyze.h"
@@ -105,6 +106,10 @@ static Node *get_element_property_expr(Oid elemoid, Oid propoid, int rtindex);
 /*
  * Convert GRAPH_TABLE clause into a subquery using relational
  * operators.
+ *
+ * If enable_native_graphtable is true (the default), the rewriting is
+ * bypassed and the RTE_GRAPH_TABLE is left intact for the native
+ * graph executor to process.
  */
 Query *
 rewriteGraphTable(Query *parsetree, int rt_index)
@@ -116,6 +121,10 @@ rewriteGraphTable(Query *parsetree, int rt_index)
 
 	rte = rt_fetch(rt_index, parsetree->rtable);
 
+	/* Native mode: leave RTE_GRAPH_TABLE intact for the planner */
+	if (enable_native_graphtable)
+		return parsetree;
+
 	Assert(list_length(rte->graph_pattern->path_pattern_list) == 1);
 
 	path_pattern = linitial(rte->graph_pattern->path_pattern_list);
diff --git a/src/include/executor/nodeGraphScan.h b/src/include/executor/nodeGraphScan.h
new file mode 100644
index 00000000000..dcee009d07c
--- /dev/null
+++ b/src/include/executor/nodeGraphScan.h
@@ -0,0 +1,22 @@
+/*-------------------------------------------------------------------------
+ *
+ * nodeGraphScan.h
+ *	  prototypes for nodeGraphScan.c
+ *
+ * Portions Copyright (c) 1996-2026, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/executor/nodeGraphScan.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef NODEGRAPHSCAN_H
+#define NODEGRAPHSCAN_H
+
+#include "nodes/execnodes.h"
+
+extern GraphScanState * ExecInitGraphScan(GraphScan * node, EState *estate, int eflags);
+extern void ExecEndGraphScan(GraphScanState * node);
+extern void ExecReScanGraphScan(GraphScanState * node);
+
+#endif							/* NODEGRAPHSCAN_H */
diff --git a/src/include/nodes/execnodes.h b/src/include/nodes/execnodes.h
index e64fd8c7ea3..1e5fd8f0891 100644
--- a/src/include/nodes/execnodes.h
+++ b/src/include/nodes/execnodes.h
@@ -2104,6 +2104,233 @@ typedef struct ForeignScanState
 	void	   *fdw_state;		/* foreign-data wrapper can keep state here */
 } ForeignScanState;
 
+/* ----------------
+ *	 GraphScanState information
+ *
+ *		GraphScan nodes are used to execute property graph scans (SQL/PGQ).
+ * ----------------
+ */
+
+/* Direction for edge traversal */
+typedef enum EdgeDirection
+{
+	GRAPH_DIR_OUTGOING = 0,		/* -(e)-> or -> */
+	GRAPH_DIR_INCOMING,			/* <-(e)- or <- */
+	GRAPH_DIR_UNDIRECTED		/* -(e)- */
+}			EdgeDirection;
+
+/* Execution modes for graph path traversal */
+typedef enum PathMode
+{
+	PATH_MODE_WALK = 0,			/* repeated vertices and edges allowed */
+	PATH_MODE_TRAIL,			/* no repeated edges allowed */
+	PATH_MODE_ACYCLIC,			/* no repeated vertices allowed */
+	PATH_MODE_SIMPLE			/* no repeated vertices except start=end */
+}			PathMode;
+
+/* Search algorithms for graph traversal */
+typedef enum SearchAlgorithm
+{
+	SEARCH_DFS = 0,				/* Depth-First Search */
+	SEARCH_BFS,					/* Breadth-First Search */
+	SEARCH_BIDIRECTIONAL,		/* Dual-ended BFS */
+}			SearchAlgorithm;
+
+/* Per-element metadata built from pg_propgraph_element during init */
+typedef struct GraphElementRelInfo
+{
+	Oid			element_oid;	/* pg_propgraph_element OID */
+	Oid			table_oid;		/* underlying heap relation OID */
+	char		element_kind;	/* 'v' for vertex, 'e' for edge */
+	Relation	heap_rel;		/* opened heap relation handle */
+	TupleDesc	tupdesc;		/* table tuple descriptor */
+
+	/*
+	 * Foreign key attribute mappings for edges.
+	 */
+	int			nsrc_fk_attnums;	/* number of source FK columns */
+	AttrNumber *src_fk_attnums; /* array of source FK attnums */
+	int			ndst_fk_attnums;	/* number of destination FK columns */
+	AttrNumber *dst_fk_attnums; /* array of destination FK attnums */
+
+	/* Vertex element OIDs that this edge connects */
+	Oid			src_vertex_elemid;	/* element OID of source vertex */
+	Oid			dest_vertex_elemid; /* element OID of destination vertex */
+
+	/* Element key: primary key attnums for vertices */
+	int			nkey_attnums;
+	AttrNumber *key_attnums;
+
+	/*
+	 * Label OIDs that this element belongs to (from
+	 * pg_propgraph_element_label)
+	 */
+	int			nlabels;
+	Oid			label_oids[32];
+}			GraphElementRelInfo;
+
+/*
+ * HopFrame - state for one hop in a multi-hop graph traversal.
+ *
+ * A hop moves from one vertex to another via edges.  Each hop has its own
+ * edge scan state, allowing independent iteration.  Multi-hop queries are
+ * chains of hop frames.
+ */
+typedef struct GraphHopFrame
+{
+	/* Edge scan state for this hop */
+	struct TableScanDescData *edge_scan;	/* active heap scan on edge table */
+	TupleTableSlot *edge_slot;	/* current edge tuple */
+	int			edge_table_index;	/* which edge catalog table we're scanning */
+	int			scan_pass;		/* 0=outgoing, 1=incoming (undirected) */
+
+	/* Source vertex: what edges are scanned FROM */
+	int			nfrom;			/* number of key columns */
+	Datum	   *from_vertex_values; /* PK values of source vertex */
+	bool	   *from_vertex_nulls;	/* null flags */
+	TupleTableSlot *from_vertex_slot;	/* source vertex tuple */
+	Oid			from_vertex_elemid; /* element_oid of the source vertex's
+									 * catalog element */
+
+	/* Current destination vertex (matched by the current edge) */
+	TupleTableSlot *to_vertex_slot; /* matched destination vertex tuple */
+	Oid			to_vertex_elemid;	/* element_oid of the destination vertex's
+									 * catalog element */
+	int			nto;			/* number of key columns */
+	Datum	   *to_vertex_values;	/* PK values of destination vertex */
+	bool	   *to_vertex_nulls;	/* null flags */
+
+	/*
+	 * For undirected scans: TID and edge catalog index of an edge already
+	 * accepted on pass 0 (outgoing).  On pass 1 (incoming), skip edges from
+	 * the same table whose TID matches, to avoid reporting the same self-loop
+	 * edge twice.
+	 */
+	ItemPointerData undirected_seen_tid;
+	int			undirected_seen_edge_idx;
+	bool		undirected_has_seen;
+
+	/*
+	 * VLE (Variable-Length Edge): DFS exploration stack for hops with a
+	 * quantifier {m,n}.  When no quantifier is present (implicit {1,1}),
+	 * vle_lower = vle_upper = 1 and the stack has capacity 2.
+	 *
+	 * Stack frames are indexed by depth (0 = source, upper = deepest).
+	 * Each frame stores the vertex identity and edge-scan resume position.
+	 * vle_stack_top is -1 when the stack is empty.
+	 */
+	bool		vle_active;			/* DFS exploration in progress */
+	int			vle_lower;			/* lower bound (1 if no quantifier) */
+	int			vle_upper;			/* upper bound (1 if no quantifier) */
+	int			vle_stack_top;		/* current stack top (-1 = empty) */
+	int			vle_stack_capacity;	/* allocated frames = vle_upper + 1 */
+	Oid		   *vle_stack_elemid;	/* element_oid per depth level */
+	int		   *vle_stack_nkeys;	/* number of key columns */
+	Datum	  **vle_stack_values;	/* PK values per depth level */
+	bool	  **vle_stack_nulls;	/* null flags per depth level */
+	int		   *vle_stack_table_idx;	/* edge table index for resume */
+	int		   *vle_stack_scan_pass;	/* scan pass for resume */
+	struct TableScanDescData **vle_stack_edge_scan;	/* own edge scan per frame */
+	TupleTableSlot **vle_stack_edge_slot;	/* own edge slot per frame */
+}			GraphHopFrame;
+
+typedef struct GraphScanState
+{
+	ScanState	ss;				/* its first field is NodeTag */
+	PathMode	path_mode;
+	SearchAlgorithm search_algo;
+
+	/* Start vertex state: how we fetch the initial vertex */
+	int			n_start_keys;	/* number of key columns */
+	Datum	   *start_vertex_values;	/* PK values of current start vertex */
+	bool	   *start_vertex_nulls; /* null flags */
+	int			start_table_index;	/* which vertex table for start */
+	TupleTableSlot *start_vertex_slot;	/* current start vertex tuple */
+	struct TableScanDescData *start_scan;	/* heap scan on start vertex table */
+
+	/* The hop chain: one GraphHopFrame per traversal */
+	GraphHopFrame *hops;
+	int			n_hops;			/* number of traversals */
+	int			current_hop;	/* active hop (-1 = fetching start vertex,
+								 * n_hops = done) */
+
+	/* Compiled expression states for WHERE clauses on elements */
+	ExprState **element_quals;	/* array of ExprState* per pattern element */
+	Node	   *where_clause;	/* raw outer GraphPattern WHERE clause (NULL
+								 * if none) */
+
+	/* Property graph OID */
+	Oid			graph_oid;
+
+	/* Catalog & runtime schema metadata */
+	int			num_elements;	/* total catalog elements in property graph */
+	GraphElementRelInfo *element_info;	/* array of opened physical relations */
+
+	/* Number of element patterns in the graph pattern's first path pattern */
+	int			n_pattern_elems;
+
+	/* Column mapping for projection */
+	int			ncols;
+	int		   *col_elem_index; /* pattern element index (-1 if constant) */
+	bool	   *col_is_const;	/* true if column is a constant */
+	Datum	   *col_const_value;	/* constant value (if col_is_const) */
+	bool	   *col_const_null; /* true if constant is NULL */
+	char	  **col_propname;	/* property name (NULL if not a graph prop) */
+	Oid		   *col_propid;		/* property OID for runtime resolution */
+	bool	   *col_prop_unsafe;	/* true if property not on ALL candidates */
+
+	/*
+	 * Cached slot pointers for column projection: slot_for_elem[pi] points to
+	 * the TupleTableSlot holding the tuple for pattern element pi.  Built
+	 * during init and updated during execution.
+	 */
+	TupleTableSlot **slot_for_elem;
+	int			num_pi;			/* number of pattern elements */
+
+	/*
+	 * Compiled column expressions from graph_table_columns. For columns that
+	 * need expression evaluation (e.g., FuncExpr wrapping a
+	 * GraphPropertyRef), we compile an ExprState that reads from the element
+	 * slot via ecxt_outertuple.  If col_exprs[ci] is NULL, the column is
+	 * handled by fill_one_slot_attr.
+	 */
+	ExprState **col_exprs;		/* array of ExprState* per scan column
+								 * (graph_table_columns index) */
+	int		   *col_expr_elem_index;	/* which pattern element index each
+										 * col_expr reads from */
+
+	/*
+	 * Shared-variable tracking: when the same variable name appears at
+	 * multiple pattern element positions (e.g., (a)->(b)->(a)), the DFS must
+	 * enforce that the same physical row is used at every occurrence. For
+	 * each pattern element index that shares a variable, we store a group id
+	 * (-1 if unique). Comparison data (PK values for vertices, edge identity)
+	 * are stored per group.
+	 */
+	int		   *samevar_group;	/* per pattern-element index: group id, or -1 */
+	int			nsamevar_groups;	/* number of same-variable groups */
+
+	/*
+	 * Per-group tracking: indexed by samevar_group[id]. The first occurrence
+	 * (lowest pi) stores the authoritative values; later occurrences compare
+	 * against them.
+	 */
+	int		   *samevar_first_pi;	/* first pattern element index in group */
+	char	   *samevar_elem_kind;	/* 'v' for vertex, 'e' for edge */
+	int		   *samevar_nkeys;	/* number of key columns */
+	Datum	  **samevar_key_values; /* stored PK values from first occurrence */
+	bool	  **samevar_key_nulls;	/* null flags for PK values */
+	ItemPointerData *samevar_tid;	/* for edges: TID of first occurrence */
+
+	/* Per-query memory context */
+	MemoryContext graph_cxt;
+
+	/* DFS safety counter */
+	long		scan_attempts;
+
+	bool		is_initialized;
+}			GraphScanState;
+
 /* ----------------
  *	 CustomScanState information
  *
@@ -2112,7 +2339,7 @@ typedef struct ForeignScanState
  * Core code must avoid assuming that the CustomScanState is only as large as
  * the structure declared here; providers are allowed to make it the first
  * element in a larger structure, and typically would need to do so.  The
- * struct is actually allocated by the CreateCustomScanState method associated
+ * struct is actually created by the CreateCustomScanState method associated
  * with the plan node.  Any additional fields can be initialized there, or in
  * the BeginCustomScan method.
  * ----------------
diff --git a/src/include/nodes/pathnodes.h b/src/include/nodes/pathnodes.h
index 27a2c6815b7..ba296421bd3 100644
--- a/src/include/nodes/pathnodes.h
+++ b/src/include/nodes/pathnodes.h
@@ -2257,6 +2257,21 @@ typedef struct CustomPath
 	const struct CustomPathMethods *methods;
 } CustomPath;
 
+/*
+ * GraphPath represents a property graph scan plan path.
+ *
+ * The graph pattern is carried in the path and eventually placed in the
+ * GraphScan plan node.
+ */
+typedef struct GraphPath
+{
+	Path		path;
+	/* OID of the property graph */
+	Oid			graph_oid;
+	/* The graph pattern to evaluate */
+	struct GraphPattern *graph_pattern;
+}			GraphPath;
+
 /*
  * AppendPath represents an Append plan, ie, successive execution of
  * several member plans.
diff --git a/src/include/nodes/plannodes.h b/src/include/nodes/plannodes.h
index b880ce0f4be..c2f9d10ebaa 100644
--- a/src/include/nodes/plannodes.h
+++ b/src/include/nodes/plannodes.h
@@ -929,6 +929,29 @@ typedef struct ForeignScan
  */
 struct CustomScanMethods;
 
+/* ----------------
+ *	   GraphScan node
+ *
+ * Native property graph scan (SQL/PGQ).  scan.scanrelid refers to an
+ * RTE_GRAPH_TABLE entry; vertex/edge tables are determined at execution
+ * time from the graph_pattern and pg_propgraph_* catalogs.
+ * ----------------
+ */
+struct GraphPattern;
+
+typedef struct GraphScan
+{
+	Scan		scan;
+	/* OID of the property graph in pg_propgraph_element et al */
+	Oid			graph_oid;
+	/* graph pattern (vertex/edge element list) to traverse */
+	struct GraphPattern *graph_pattern;
+	/* execution mode: WALK, TRAIL, etc. (see PathMode) */
+	int			path_mode;
+	/* search algorithm: DFS, BFS, etc. (see SearchAlgorithm) */
+	int			search_algo;
+}			GraphScan;
+
 typedef struct CustomScan
 {
 	Scan		scan;
diff --git a/src/include/optimizer/cost.h b/src/include/optimizer/cost.h
index bda3f1690c0..6536bf55531 100644
--- a/src/include/optimizer/cost.h
+++ b/src/include/optimizer/cost.h
@@ -71,6 +71,8 @@ extern PGDLLIMPORT bool enable_parallel_hash;
 extern PGDLLIMPORT bool enable_partition_pruning;
 extern PGDLLIMPORT bool enable_presorted_aggregate;
 extern PGDLLIMPORT bool enable_async_append;
+extern PGDLLIMPORT bool enable_native_graphtable;
+extern PGDLLIMPORT int max_vle_stack_depth;
 extern PGDLLIMPORT int constraint_exclusion;
 
 extern double index_pages_fetched(double tuples_fetched, BlockNumber pages,
diff --git a/src/test/regress/sql/graph_table.sql b/src/test/regress/sql/graph_table.sql
index 3fb0e50ddb2..8f09dad1792 100644
--- a/src/test/regress/sql/graph_table.sql
+++ b/src/test/regress/sql/graph_table.sql
@@ -91,7 +91,6 @@ SELECT customer_name FROM GRAPH_TABLE (myshop MATCH (c IS customers|employees WH
 SELECT customer_name FROM GRAPH_TABLE (myshop MATCH (c IS customers WHERE c.address = 'US')-[IS customer_orders] COLUMNS (c.name AS customer_name));  -- error
 SELECT * FROM GRAPH_TABLE (myshop MATCH (c IS customers), (o IS orders) COLUMNS (c.name AS customer_name));  -- error
 SELECT * FROM GRAPH_TABLE (myshop MATCH COLUMNS (1 AS col));  -- error, empty match clause
-SELECT customer_name FROM GRAPH_TABLE (myshop MATCH (c IS customers)->{1,2}(o IS orders) COLUMNS (c.name AS customer_name));  -- error
 SELECT * FROM GRAPH_TABLE (myshop MATCH ((c IS customers)->(o IS orders)) COLUMNS (c.name));
 
 -- a property graph can be referenced only from within GRAPH_TABLE clause.
@@ -287,10 +286,10 @@ SELECT count(*) FROM GRAPH_TABLE (g1 MATCH ()->() COLUMNS (1 AS one));
 -- of label vl2.
 SELECT * FROM GRAPH_TABLE (g1 MATCH (a IS vl1 | vl2) COLUMNS (a.vname, a.vprop1));
 -- vprop2 is associated with vl2 but not vl3
-SELECT src, conn, dest, lprop1, vprop2, vprop1 FROM GRAPH_TABLE (g1 MATCH (a IS vl1)-[b IS el1]->(c IS vl2 | vl3) COLUMNS (a.vname AS src, b.ename AS conn, c.vname AS dest, c.lprop1, c.vprop2, c.vprop1));
+SELECT src, conn, dest, lprop1, vprop2, vprop1 FROM GRAPH_TABLE (g1 MATCH (a IS vl1)-[b IS el1]->(c IS vl2 | vl3) COLUMNS (a.vname AS src, b.ename AS conn, c.vname AS dest, c.lprop1, c.vprop2, c.vprop1)) ORDER BY src, conn, dest;
 -- edges directed in both ways - to and from v2
-SELECT * FROM GRAPH_TABLE (g1 MATCH (v1 IS vl2)-[conn]-(v2) COLUMNS (v1.vname AS v1name, conn.ename AS cname, v2.vname AS v2name));
-SELECT * FROM GRAPH_TABLE (g1 MATCH (v1 IS vl2)-(v2) COLUMNS (v1.vname AS v1name, v2.vname AS v2name));
+SELECT * FROM GRAPH_TABLE (g1 MATCH (v1 IS vl2)-[conn]-(v2) COLUMNS (v1.vname AS v1name, conn.ename AS cname, v2.vname AS v2name)) ORDER BY v1name, v2name;
+SELECT * FROM GRAPH_TABLE (g1 MATCH (v1 IS vl2)-(v2) COLUMNS (v1.vname AS v1name, v2.vname AS v2name)) ORDER BY v1name, v2name;
 
 -- Errors
 -- vl1 is not associated with property vprop2
@@ -319,15 +318,15 @@ SELECT * FROM GRAPH_TABLE (g1 MATCH (WHERE b.eprop1 = 10001)-[b]->(c) COLUMNS (b
 
 -- select all the properties across all the labels associated with a given type
 -- of graph element
-SELECT * FROM GRAPH_TABLE (g1 MATCH (src)-[conn]->(dest) COLUMNS (src.vname AS svname, conn.ename AS cename, dest.vname AS dvname, src.vprop1 AS svp1, src.vprop2 AS svp2, src.lprop1 AS slp1, dest.vprop1 AS dvp1, dest.vprop2 AS dvp2, dest.lprop1 AS dlp1, conn.eprop1 AS cep1, conn.lprop2 AS clp2));
+SELECT * FROM GRAPH_TABLE (g1 MATCH (src)-[conn]->(dest) COLUMNS (src.vname AS svname, conn.ename AS cename, dest.vname AS dvname, src.vprop1 AS svp1, src.vprop2 AS svp2, src.lprop1 AS slp1, dest.vprop1 AS dvp1, dest.vprop2 AS dvp2, dest.lprop1 AS dlp1, conn.eprop1 AS cep1, conn.lprop2 AS clp2)) ORDER BY svname, cename;
 -- three label disjunction
-SELECT * FROM GRAPH_TABLE (g1 MATCH (src IS vl1 | vl2 | vl3)-[conn]->(dest) COLUMNS (src.vname AS svname, conn.ename AS cename, dest.vname AS dvname));
+SELECT * FROM GRAPH_TABLE (g1 MATCH (src IS vl1 | vl2 | vl3)-[conn]->(dest) COLUMNS (src.vname AS svname, conn.ename AS cename, dest.vname AS dvname)) ORDER BY svname, cename;
 -- graph'ical query: find a vertex which is not connected to any other vertex as a source or a destination.
 WITH all_connected_vertices AS (SELECT svn, dvn FROM GRAPH_TABLE (g1 MATCH (src)-[conn]->(dest) COLUMNS (src.vname AS svn, dest.vname AS dvn))),
     all_vertices AS (SELECT vn FROM GRAPH_TABLE (g1 MATCH (vertex) COLUMNS (vertex.vname AS vn)))
 SELECT vn FROM all_vertices EXCEPT (SELECT svn FROM all_connected_vertices UNION SELECT dvn FROM all_connected_vertices) ORDER BY vn;
 -- query all connections using a label shared by vertices and edges
-SELECT sn, cn, dn FROM GRAPH_TABLE (g1 MATCH (src IS l1)-[conn IS l1]->(dest IS l1) COLUMNS (src.elname AS sn, conn.elname AS cn, dest.elname AS dn));
+SELECT sn, cn, dn FROM GRAPH_TABLE (g1 MATCH (src IS l1)-[conn IS l1]->(dest IS l1) COLUMNS (src.elname AS sn, conn.elname AS cn, dest.elname AS dn)) ORDER BY sn, cn;
 
 -- Tests for cyclic path patterns
 CREATE TABLE e2_1 (
@@ -619,6 +618,16 @@ SELECT src.vname, count(*) FROM v1 AS src
   HAVING count(*) >= (SELECT count(*) FROM GRAPH_TABLE (g1 MATCH (a IS vl1 | vl2) COLUMNS (a.vname AS n)) WHERE n = src.vname)
   ORDER BY vname;
 
+ALTER PROPERTY GRAPH g1 DROP EDGE TABLES (e3_3); -- simplify the graph
+-- VLE (Variable-Length Edge) patterns
+SELECT src FROM GRAPH_TABLE (g1 MATCH (a)->{0}() COLUMNS (a.vname AS src)) ORDER BY src;
+SELECT src, dst FROM GRAPH_TABLE (g1 MATCH (a)->{2}(b) COLUMNS (a.vname AS src, b.vname AS dst)) ORDER BY src, dst;
+SELECT src, dst FROM GRAPH_TABLE (g1 MATCH (a)->{1,3}(b) COLUMNS (a.vname AS src, b.vname AS dst)) ORDER BY src, dst;
+SELECT src, dst FROM GRAPH_TABLE (g1 MATCH (a)->{2,}(b) COLUMNS (a.vname AS src, b.vname AS dst)) ORDER BY src, dst; -- depth error
+SELECT src, dst FROM GRAPH_TABLE (g1 MATCH (a)->{,2}(b) COLUMNS (a.vname AS src, b.vname AS dst)) ORDER BY src, dst;
+-- SELECT src, mid, dst FROM GRAPH_TABLE (g1 MATCH (a)->{,2}(b)->(c) COLUMNS (a.vname AS src, b.vname AS mid, c.vname AS dst)) ORDER BY src, mid, dst;
+SELECT src, dst FROM GRAPH_TABLE (g1 MATCH (a)-[e]-{2}(b) COLUMNS (a.vname AS src, b.vname AS dst)) ORDER BY src, dst;
+
 -- Locking clause on GRAPH_TABLE
 SELECT * FROM GRAPH_TABLE (g1 MATCH (src IS vl1) COLUMNS (src.vname)) gt FOR UPDATE OF gt;  -- not supported
 SELECT * FROM GRAPH_TABLE (g1 MATCH (src IS vl1) COLUMNS (src.vname)) gt FOR UPDATE;  -- ignored
